Index: /trunk/src/sys/arch/mips/rmi/rmixl_spl.S
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_spl.S	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_spl.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_spl.S,v 1.1.2.2 2010/04/14 01:23:15 cliff Exp $	*/
+/*	$NetBSD: rmixl_spl.S,v 1.1.2.6 2011/04/29 08:26:33 matt Exp $	*/
 
 /*-
@@ -38,13 +38,13 @@
 #include <mips/cpuregs.h>
 
-RCSID("$NetBSD: rmixl_spl.S,v 1.1.2.2 2010/04/14 01:23:15 cliff Exp $");
+RCSID("$NetBSD: rmixl_spl.S,v 1.1.2.6 2011/04/29 08:26:33 matt Exp $");
 
 #include "assym.h"
 
-#define PARANOIA	/* XXX TMP FIXME */
-
 #define MAP_SCALESHIFT		3
-#define RMIXL_SOFT_INT_MASK_0	(MIPS_SOFT_INT_MASK_1 >> 8)
+#define RMIXL_SOFT_INT_MASK_1	(MIPS_SOFT_INT_MASK_1 >> 8)
 #define RMIXL_SOFT_INT_MASK	(MIPS_SOFT_INT_MASK >> 8)
+#define RMIXL_INT_MASK_5	(MIPS_INT_MASK_5 >> 8)
+#define RMIXL_EIRR_PRESERVE	(RMIXL_INT_MASK_5 | RMIXL_SOFT_INT_MASK)
 #define RMIXL_INT_MASK_1	(MIPS_INT_MASK_1 >> 8)
 #define RMIXL_INT_MASK_5	(MIPS_INT_MASK_5 >> 8)
@@ -52,24 +52,51 @@
 #define RMIXL_COP_0_EIMR	_(9), 7
 
+	.set noreorder
 
 /* 
  * Array of mask of bits to set in the EIMR when we go to a
  * given hardware interrupt priority level.
+ * The softint bits in [IPL_NONE] and [IPL_SOFTCLOCK] should stay constant
+ * Hard intr bits are managed by rmixl_vec_establish and rmixl_vec_disestablish.
  */
-	.rdata
+	.data
 	.globl	_C_LABEL(ipl_eimr_map)
 	.type	_C_LABEL(ipl_eimr_map),@object
 	.p2align MAP_SCALESHIFT
 _C_LABEL(ipl_eimr_map):
-	.dword	~0			/* IPL_NONE */
-	.dword	~RMIXL_SOFT_INT_MASK_0	/* IPL_SOFT{CLOCK,BIO} */
-	.dword	~RMIXL_SOFT_INT_MASK	/* IPL_SOFT{NET,SERIAL} */
-	.dword	RMIXL_INT_MASK_5	/* IPL_VM */
+	.dword	RMIXL_SOFT_INT_MASK	/* IPL_NONE */
+	.dword	RMIXL_SOFT_INT_MASK_1	/* IPL_SOFT{CLOCK,BIO} */
+	.dword	0			/* IPL_SOFT{NET,SERIAL} */
+	.dword	0			/* IPL_VM */
 	.dword	0			/* IPL_SCHED */
-#if IPL_SCHED != IPL_HIGH
+	.dword	0			/* IPL_DDB */
 	.dword	0			/* IPL_HIGH */
-#endif
 
 	.text
+
+/*
+ * initialize cp0 interrupt control for this cpu
+ * - set STATUS[IE]
+ * - clear EIRR and EIMR
+ * on return, all interrupts are disabled by EIMR
+ *
+ * henceforth STATUS[IE] is expected to remain normally set
+ * but may be cleared and restored for temporary interrupt disablement
+ *
+ * call before the first call to spl0 on this cpu
+ */
+LEAF_NOPROFILE(rmixl_spl_init_cpu)
+	mfc0	t0, MIPS_COP_0_STATUS		# get STATUS
+	ori	t0, MIPS_SR_INT_IE		# set IE
+	mtc0	zero, MIPS_COP_0_STATUS		## disable all ints in STATUS
+	COP0_SYNC
+	dmtc0	zero, RMIXL_COP_0_EIMR		##  "       "   "   "  EIMR
+	COP0_SYNC
+	dmtc0	zero, RMIXL_COP_0_EIRR		## clear EIRR
+	COP0_SYNC
+	mtc0	t0, MIPS_COP_0_STATUS		## set STATUS | IE
+	JR_HB_RA
+END(rmixl_spl_init_cpu)
+
 /*
  * RMIXL processor interrupt control
@@ -77,139 +104,84 @@
  * Used as building blocks for spl(9) kernel interface.
  */
+
 _splraise:
 	/*
-	 * a0 = EIMR bits to be set for this IPL
+	 * a0 = EIMR bits requested to be set for this IPL
 	 * a1 = this IPL (IPL_*)
 	 * Can only use a0-a3 and v0-v1
+	 * old IPL is returned in v0
 	 */
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
-	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
-	sltu	v1, a1, v0			# newipl < curipl
-	bnez	v1, 2f				# yes, don't change.
-	 mfc0	a2, MIPS_COP_0_STATUS		# load STATUS
-	and	a2, ~MIPS_INT_MASK		# clear STATUS[IM]
-	sll	v1, a0, 8			# EIMR[7:0] to STATUS[15:8]
-	and	v1, MIPS_INT_MASK		#  "        "   "
-	or	v1, a2				# new STATUS value
-	mtc0	zero, MIPS_COP_0_STATUS		## disable all ints in STATUS
+	dmfc0	a2, RMIXL_COP_0_EIMR		# save EIMR
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		##
+	INT_L	v0, CPU_INFO_CPL(a3)		## get current IPL from cpu_info
+	sltu	v1, a1, v0			## newipl < curipl
+	bnez	v1, 1f				## yes, don't change.
+	 nop
 	INT_S	a1, CPU_INFO_CPL(a3)		## save IPL in cpu_info
 	dmtc0	a0, RMIXL_COP_0_EIMR		## set new EIMR
-	mtc0	v1, MIPS_COP_0_STATUS		## set new STATUS
-#ifdef PARANOIA
-	j	ra
-	 nop
-#endif /* PARANOIA */
-#ifdef PARANOIA
-	dmfc0	v0, RMIXL_COP_0_EIMR		# get EIMR
-1:	bne	a0, v0, 1b			# loop forever if not equal
-	 nop
-#endif /* PARANOIA */
-2:	j	ra
-	 nop
+	JR_HB_RA
+1:
+	dmtc0	a2, RMIXL_COP_0_EIMR		## restore saved EIMR
+	JR_HB_RA
 
 STATIC_LEAF(_splsw_splx)
 STATIC_XLEAF(_splsw_splx_noprof)		# does not get mcount hooks
-	PTR_L	a3, L_CPU(MIPS_CURLWP)		# get cpu_info
-	INT_L	a2, CPU_INFO_CPL(a3)		# get IPL from cpu_info
-	beq	a0, a2, 2f			# if same, nothing to do
-	 nop
-#ifdef PARANOIA
-	sltu	v0, a0, a2			# v0 = a0 < a2
-99:	beqz	v0, 99b				# loop forever if false
-	 nop
-#endif /* PARANOIA */
-	#move	a1, zero			# avoid lookup on splx(IPL_NONE)
-	#beq	a0, zero, 1f			# skip load
 	PTR_LA	v1, _C_LABEL(ipl_eimr_map)	# get address of table
 	sll	a2, a0, MAP_SCALESHIFT		# convert IPL to array offset
 	PTR_ADDU v1, a2				# add to table addr
 	REG_L	v1, (v1)			# load EIMR bits for this IPL
-1:
-	dmfc0	a2, MIPS_COP_0_STATUS		# load STATUS
-	and	a2, ~MIPS_INT_MASK		# clear STATUS[IM]
-	sll	v0, v1, 8			# EIMR[7:0] to STATUS[15:8]
-	and	v0, MIPS_INT_MASK		#  "        "   "
-	or	v0, a2				# new STATUS value
-	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
-	INT_S	a0, CPU_INFO_CPL(a3)		## save IPL in cpu_info (KSEG0)
+
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		## get cpu_info
+	INT_S	a0, CPU_INFO_CPL(a3)		## save IPL in cpu_info
 	dmtc0	v1, RMIXL_COP_0_EIMR		## set new EIMR
-	mtc0	v0, MIPS_COP_0_STATUS		## set new STATUS
-#ifdef PARANOIA
-	j	ra
-	 nop
-#endif /* PARANOIA */
-2:
-#ifdef PARANOIA
-	PTR_LA	v1, _C_LABEL(ipl_eimr_map)	# get address of table
-	sll	a2, a0, MAP_SCALESHIFT		# convert IPL to array offset
-	PTR_ADDU v1, a2				# add to table addr
-	REG_L	a1, (v1)			# load EIMR bits for this IPL
-	dmfc0	v1, RMIXL_COP_0_EIMR		# get EIMR
-3:	bne	a1, v1, 3b			# loop forever if not equal
-	 nop
-#endif /* PARANOIA */
-	j	ra
-	 nop
+	JR_HB_RA
 END(_splsw_splx)
 
 STATIC_LEAF(_splsw_spl0)
 	REG_L	v1, _C_LABEL(ipl_eimr_map) + 8*IPL_NONE
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
-	mtc0	zero, MIPS_COP_0_CAUSE		# clear SOFT_INT bits
-	dmfc0	a2, MIPS_COP_0_STATUS		# load STATUS
-	and	a2, ~MIPS_INT_MASK		# clear STATUS[IM]
-	sll	v0, v1, 8			# EIMR[7:0] to STATUS[15:8]
-	and	v0, MIPS_INT_MASK		#  "        "   "
-	or	v0, MIPS_SR_INT_IE		# set STATUS[IE]
-	or	v0, a2				# new STATUS value
-	mtc0	zero, MIPS_COP_0_STATUS		## disable all interrupts
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		## get cpu_info
 #if IPL_NONE == 0
-	INT_S	zero, CPU_INFO_CPL(a3)		## set ipl to 0
+	INT_S	zero, CPU_INFO_CPL(a3)		## save IPL in cpu_info
 #else
 #error IPL_NONE != 0
 #endif
 	dmtc0	v1, RMIXL_COP_0_EIMR		## set new EIMR
-	mtc0	v0, MIPS_COP_0_STATUS		## set new STATUS
-	nop
-	nop
-	j	ra
-	 nop
+	JR_HB_RA
 END(_splsw_spl0)
 
-LEAF_NOPROFILE(rmixl_spln)
-	PTR_LA	v1, _C_LABEL(ipl_eimr_map)	# get address of table
-	sll	a2, a0, MAP_SCALESHIFT		# convert IPL to array offset
-	PTR_ADDU v1, a2				# add to table addr
-	REG_L	v0, (v1)			# load EIMR bits for this IPL
-	j	ra
-	 nop
-END(rmixl_spln)
-
 STATIC_LEAF(_splsw_setsoftintr)
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		## disable interrupts (2 cycles)
-	nop
-	nop
-	mfc0	v0, MIPS_COP_0_CAUSE		## load cause register
-	nop
-	or	v0, v0, a0			## set soft intr. bits
-	mtc0	v0, MIPS_COP_0_CAUSE		## store back
-	mtc0	v1, MIPS_COP_0_STATUS		## enable interrupts
-	j	ra
-	nop
+	dsrl	a0, 8				# convert CAUSE bit to EIRR bit
+	and	a0, RMIXL_SOFT_INT_MASK		# restrict to softint bits
+	dmfc0	v1, RMIXL_COP_0_EIMR		# save EIMR register
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	dmfc0	v0, RMIXL_COP_0_EIRR		## load EIRR
+	and	v0, RMIXL_EIRR_PRESERVE		## preserve clock & softints
+	or	v0, a0				## set new softint bit
+	dmtc0	v0, RMIXL_COP_0_EIRR		## store EIRR
+	COP0_SYNC
+	dmtc0	v1, RMIXL_COP_0_EIMR		## restore EIMR
+	JR_HB_RA
 END(_splsw_setsoftintr)
 
 STATIC_LEAF(_splsw_clrsoftintr)
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		## disable interrupts (2 cycles)
-	nop
-	nop
-	mfc0	v0, MIPS_COP_0_CAUSE		## load cause register
-	nor	a0, zero, a0			## bitwise inverse of A0
-	and	v0, v0, a0			## clear soft intr. bits
-	mtc0	v0, MIPS_COP_0_CAUSE		## store back
-	mtc0	v1, MIPS_COP_0_STATUS		## enable interrupts
-	j	ra
-	nop
+	dsrl	a0, 8				# convert CAUSE bit to EIRR bit
+	and	a0, RMIXL_SOFT_INT_MASK		# restrict to softint bits
+	xor	a0, RMIXL_EIRR_PRESERVE		# clear from preserve mask
+	dmfc0	v1, RMIXL_COP_0_EIMR		# save EIMR register
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	dmfc0	v0, RMIXL_COP_0_EIRR		## load EIRR
+	and	v0, a0				## apply preserve mask
+	dmtc0	v0, RMIXL_COP_0_EIRR		## store EIRR
+	COP0_SYNC
+	dmtc0	v1, RMIXL_COP_0_EIMR		## restore EIMR
+	JR_HB_RA
 END(_splsw_clrsoftintr)
 
@@ -226,30 +198,21 @@
 STATIC_LEAF(_splsw_splhigh)
 STATIC_XLEAF(_splsw_splhigh_noprof)
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
-	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
-	li	a1, IPL_HIGH			# 
-	beq	v0, a1, 1f			# don't do anything if IPL_HIGH
-	mfc0	v1, MIPS_COP_0_STATUS		# load STATUS
-	move	a2, zero			# clear for EIMR
-	and	a0, v1, MIPS_INT_MASK		# select all interrupts
-	xor	a0, v1				# clear STATUS[IM]
-	mtc0	zero, MIPS_COP_0_STATUS		## disable all interrupts
+	dmtc0	zero, RMIXL_COP_0_EIMR		## disable all interrupts
+	COP0_SYNC
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		## get cpu_info from curlwp
+	li	a1, IPL_HIGH			##
+	INT_L	v0, CPU_INFO_CPL(a3)		## old IPL for return value
 	INT_S	a1, CPU_INFO_CPL(a3)		## save IPL in cpu_info
-	dmtc0	a2, RMIXL_COP_0_EIMR		## set new EIMR
-	mtc0	a0, MIPS_COP_0_STATUS		## set new STATUS
-	 nop					# XXXXX
-#ifdef PARANOIA
+						## interrupts remain disabled!
 	j	ra				# return
 	 nop
-#endif /* PARANOIA */
-1:
-#ifdef PARANOIA
-	dmfc0	v1, RMIXL_COP_0_EIMR		# load EIMR
-2:	bnez	v1, 2b				# loop forever if not 0.
-	 nop
-#endif /* PARANOIA */
-	j	ra				## return
-	 nop
 END(_splsw_splhigh)
+
+STATIC_LEAF(_splsw_splddb)
+	REG_L	a0, _C_LABEL(ipl_eimr_map) + 8*IPL_DDB
+	li	a1, IPL_DDB
+	b	_splraise
+	 nop
+END(_splsw_splddb)
 
 STATIC_LEAF(_splsw_splsched)
@@ -298,26 +261,23 @@
 	dmfc0	ta1, RMIXL_COP_0_EIRR		# get active interrupts
 						# restrict to hard int bits:
-	and	v1, ta1, RMIXL_SOFT_INT_MASK	#  v1 &= ~RMIXL_SOFT_INT_MASK
-	xor	v1, ta1				#   "      "
-
-	li	v0, IPL_NONE			# return IPL_NONE ...
-	beq	v1, zero, 2f			# ... if nothing pending
-	 nop
-
-	li	v0, IPL_VM			# start at IPL_VM
+	and	v1, ta1, RMIXL_SOFT_INT_MASK	#  v1 = ta1 & ~RMIXL_SOFT_INT_MASK
+	xor	v1, ta1				#   "       "
+
+	li	v0, IPL_NONE
 	PTR_LA	ta3, _C_LABEL(ipl_eimr_map) + 8*IPL_VM
 	REG_L	ta2, -8(ta3)			# load 'enabled' bits for IPL_SOFTSERIAL
-						#  ta2 has 'enabled' ints
 	and	v1, ta2				# apply to pending bits
-
+	beq	v1, zero, 4f			# if nothing pending...
+	 nop					# ... return IPL_NONE
+
+	li	v0, IPL_VM			# ipl=IPL_VM
 1:
-	REG_L	ta2, (ta3)			# load 'enabled' bits for ipl in v0
+	REG_L	ta2, (ta3)			# load 'enabled' bits for ipl
 	and	ta2, v1				# any match to pending intrs?
 	beq	ta2, zero, 2f			#  no, return ipl
-
-	PTR_ADDU ta3, 1 << MAP_SCALESHIFT	# point to next entry
-	addiu	v0, 1				#  increase ipl by 1
-	move	v1, ta2				# reduce down pending intrs
-	b	1b				# and check them
+	 PTR_ADDI ta3, 1 << MAP_SCALESHIFT	#  point to next entry
+	addiu	v0, 1				# ipl++
+	move	v1, ta2				# update highest pending
+	b	1b				# loop
 	 nop
 
@@ -330,6 +290,5 @@
 	 *   individial EIRR requests
 	 */
-	beq	v1, zero, 4f			# skip ahead if nothing pending
-	 li	t2, RMIXL_INT_MASK_5		# load RMIXL_INT_MASK_5
+	li	t2, RMIXL_INT_MASK_5		# load RMIXL_INT_MASK_5
 	and	t1, v1, t2			# save count/compare intr request value
 	nor	t0, zero, t2			# invert the mask
Index: /trunk/src/sys/arch/mips/rmi/rmixl_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_subr.S	(revision 152)
@@ -1,3 +1,4 @@
-/*	$NetBSD: rmixl_subr.S,v 1.1.2.7 2010/04/13 18:15:16 cliff Exp $	*/
+/*	rmixl_subr.S,v 1.1.2.8 2011/04/29 08:26:34 matt Exp	*/
+
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -37,10 +38,14 @@
 #include <mips/cpuregs.h>
 
+RCSID("rmixl_subr.S,v 1.1.2.8 2011/04/29 08:26:34 matt Exp");
+
 #include "assym.h"
 
-	.set	push
-        .set    noreorder
-        .set    mips64
-        .text
+#define RMIXL_COP_0_EIRR	_(9), 6
+#define RMIXL_COP_0_EIMR	_(9), 7
+
+	.set    noreorder
+	.set	arch=xlr
+	.text
 
 /*
@@ -54,5 +59,5 @@
 #endif
 	j	ra
-	mfcr	v0, a0
+	 mfcr	v0, a0
 END(rmixl_mfcr)
 
@@ -67,6 +72,26 @@
 #endif
 	j	ra
-	mtcr	a1, a0
+	 mtcr	a1, a0
 END(rmixl_mtcr)
+
+/*
+ * void rmixl_eirr_ack(uint64_t eimr, uint64_t vecbit, uint64_t preserve)
+ *
+ *	ack in EIRR the irq we are about to handle
+ *	disable all interrupts to prevent a race that would allow
+ *	e.g. softints set from a higher interrupt getting
+ *	clobbered by the EIRR read-modify-write 
+ */
+LEAF(rmixl_eirr_ack)
+	dmtc0	zero, RMIXL_COP_0_EIMR	/* EIMR = 0 */
+	COP0_SYNC
+	dmfc0	a3, RMIXL_COP_0_EIRR	/* a3 = EIRR */
+	and	a3, a2			/* a3 &= preserve */
+	or	a3, a1			/* a3 |= vecbit */
+	dmtc0	a3, RMIXL_COP_0_EIRR	/* EIRR = a3 */
+	COP0_SYNC
+	dmtc0	a0, RMIXL_COP_0_EIMR	/* EIMR = eimr */
+	JR_HB_RA
+END(rmixl_eirr_ack)
 
 #ifdef MULTIPROCESSOR
@@ -109,7 +134,11 @@
 NESTED(rmixl_cpu_trampoline, CALLFRAME_SIZ, ra)
 #ifdef _LP64
+	/*
+	 * reconstruct trampoline args addr:
+	 * sign-extend 32 bit KSEG0 address in a0
+	 * to make proper 64 bit KSEG0 addr
+	 */
+	sll		s0, a0, 0
 	li		t0, MIPS_SR_KX
-	li		t1, MIPS_KSEG0_START	/* reconstruct presumed upper half ... */
-	or		a0, a0, t1		/* ... of trampoline args addr */
 #else
 	li		t0, 0
@@ -128,5 +157,5 @@
 	 * load our stack pointer from trampoline args
 	 */
-	REG_L		sp, 0*SZREG(a0)		/* XXX ta_sp */
+	REG_L		sp, 0*SZREG(s0)		/* XXX ta_sp */
 
 	/*
@@ -134,5 +163,5 @@
 	 * save in t8 reg dedicated as 'mips_curlwp'
 	 */
-	REG_L		t8, 1*SZREG(a0)		/* XXX ta_lwp */
+	REG_L		t8, 1*SZREG(s0)		/* XXX ta_lwp */
 
 	/*
@@ -140,7 +169,12 @@
 	 * jump to common mips cpu_trampoline
 	 */
-	REG_L		a1, 2*SZREG(a0)		/* XXX ta_cpuinfo */
+	REG_L		a1, 2*SZREG(s0)		/* XXX ta_cpuinfo */
+	dmtc0		a1, $22, 0		/* MIPS_COP_0_OSSCRATCH */
+	PTR_L		v1, CPU_INFO_TLB_INFO(a1)
+	PTR_L		v1, TI_LOCK(v1)
+	PTR_ADDU	v1, MTX_LOCK
+	dmtc0		v1, $22, 2
 	j		cpu_trampoline
-	 mtc0		a1, $22, 0		/* MIPS_COP_0_OSSCRATCH */
+	 nop
 
 	/* NOTREACHED */
@@ -149,5 +183,2 @@
 
 #endif	/* MULTIPROCESSOR */
-
-	.set	pop
-
Index: /trunk/src/sys/arch/mips/rmi/rmixl_usbi.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_usbi.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_usbi.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_usbi.c,v 1.1.2.5 2010/04/12 22:42:07 cliff Exp $	*/
+/*	$NetBSD: rmixl_usbi.c,v 1.1.2.7 2011/04/29 08:26:34 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_usbi.c,v 1.1.2.5 2010/04/12 22:42:07 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_usbi.c,v 1.1.2.7 2011/04/29 08:26:34 matt Exp $");
 
 #include "locators.h"
@@ -62,5 +62,5 @@
 #define RMIXL_USBI_GEN_WRITE(o,v)  *RMIXL_USBI_GEN_VADDR(o) = htole32(v)
 
-static const char *rmixl_usbi_intrnames[RMIXL_UB_INTERRUPT_MAX+1] = {
+static const char rmixl_usbi_intrnames[RMIXL_UB_INTERRUPT_MAX+1][16] = {
 	"int 0 (ohci0)",
 	"int 1 (ohci1)",
@@ -70,21 +70,4 @@
 	"int 5 (force)"
 };
-
-typedef struct rmixl_usbi_dispatch {
-	int (*func)(void *);
-	void *arg; 
-	struct evcnt count;
-} rmixl_usbi_dispatch_t;
-
-typedef struct rmixl_usbi_softc {
-	device_t		sc_dev;
-	bus_space_tag_t		sc_eb_bst;
-	bus_space_tag_t		sc_el_bst;
-	bus_addr_t		sc_addr;
-	bus_size_t		sc_size;
-	bus_dma_tag_t		sc_dmat;
-	rmixl_usbi_dispatch_t	sc_dispatch[RMIXL_UB_INTERRUPT_MAX + 1];
-} rmixl_usbi_softc_t;
-
 
 static int	rmixl_usbi_match(device_t, cfdata_t, void *);
@@ -147,10 +130,6 @@
 	 */
         r = RMIXL_IOREG_READ(RMIXL_IO_DEV_GPIO + RMIXL_GPIO_BIST_EACH_STS);
-	aprint_normal(": BIST status=");
-	if ((r & __BIT(18)) == 0) {			/* XXX USB_BIST */
-		aprint_normal("FAIL\n");
-		return;
-	}
-	aprint_normal("OK");
+	aprint_normal(": BIST status=%s,",
+	    (r & __BIT(18)) ? "OK" : "FAIL");		/* XXX USB_BIST */
 
 	/*
@@ -174,9 +153,12 @@
 
 	/* establish interrupt */
-	ih = rmixl_intr_establish(obio->obio_intr, obio->obio_tmsk,
-		IPL_USB, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
-		rmixl_usbi_intr, sc, false);
-	if (ih == NULL)
-		panic("%s: couldn't establish interrupt", device_xname(self));
+	if (obio->obio_intr != OBIOCF_INTR_DEFAULT) {
+		ih = rmixl_intr_establish(obio->obio_intr, obio->obio_tmsk,
+			IPL_USB, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
+			rmixl_usbi_intr, sc, false);
+		if (ih == NULL)
+			panic("%s: couldn't establish interrupt",
+				device_xname(self));
+	}
 
 	aprint_normal("\n");
Index: /trunk/src/sys/arch/mips/rmi/rmixl_usbivar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_usbivar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_usbivar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_usbivar.h,v 1.1.2.1 2009/12/14 07:21:41 cliff Exp $	*/
+/*	$NetBSD: rmixl_usbivar.h,v 1.1.2.2 2011/04/29 08:26:34 matt Exp $	*/
 
 /*-
@@ -45,6 +45,26 @@
 };
 
-extern void *rmixl_usbi_intr_establish(void *, u_int, int (*)(void *), void *);
-extern void  rmixl_usbi_intr_disestablish(void *, void *);
+typedef struct rmixl_usbi_dispatch {
+	int (*func)(void *);
+	void *arg; 
+	struct evcnt count;
+} rmixl_usbi_dispatch_t;
+
+typedef struct rmixl_usbi_softc {
+	device_t		sc_dev;
+	bus_space_tag_t		sc_eb_bst;
+	bus_space_tag_t		sc_el_bst;
+	bus_addr_t		sc_addr;
+	bus_size_t		sc_size;
+	bus_dma_tag_t		sc_dmat;
+	device_t		sc_ohci_devs[2];
+	rmixl_usbi_dispatch_t	sc_dispatch[RMIXL_UB_INTERRUPT_MAX + 1];
+} rmixl_usbi_softc_t;
+
+
+#ifdef _KERNEL
+void *rmixl_usbi_intr_establish(void *, u_int, int (*)(void *), void *);
+void  rmixl_usbi_intr_disestablish(void *, void *);
+#endif
 
 #endif /* _MIPS_RMI_RMIXL_USBIVAR_H_ */
Index: /trunk/src/sys/arch/mips/rmi/rmixlvar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixlvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixlvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixlvar.h,v 1.1.2.18 2010/04/17 07:33:33 cliff Exp $	*/
+/*	$NetBSD: rmixlvar.h,v 1.1.2.20 2011/04/29 08:26:34 matt Exp $	*/
 
 /*
@@ -47,4 +47,6 @@
 #include <dev/pci/pcivar.h>
 
+extern void rmixl_pcr_init_core(void);
+
 static inline bool
 cpu_rmixl(const struct pridtab *ct)
@@ -111,4 +113,6 @@
 struct rmixl_config {
 	uint64_t		 rc_io_pbase;	
+	uint64_t		 rc_flash_pbase;	/* FLASH_BAR */
+	uint64_t		 rc_flash_mask;		/* FLASH_BAR */
 	bus_addr_t		 rc_pci_cfg_pbase;	
 	bus_size_t		 rc_pci_cfg_size;
@@ -121,4 +125,5 @@
 	struct mips_bus_space	 rc_obio_eb_memt; 	/* DEVIO -eb */
 	struct mips_bus_space	 rc_obio_el_memt; 	/* DEVIO -el */
+	struct mips_bus_space	 rc_iobus_memt; 	/* Peripherals IO Bus */
 	struct mips_bus_space	 rc_pci_cfg_memt; 	/* PCI CFG  */
 	struct mips_bus_space	 rc_pci_ecfg_memt; 	/* PCI ECFG */
@@ -132,4 +137,5 @@
 	struct extent		*rc_obio_eb_ex;
 	struct extent		*rc_obio_el_ex;
+	struct extent		*rc_iobus_ex;
 	struct extent		*rc_pci_cfg_ex;
 	struct extent		*rc_pci_ecfg_ex;
@@ -148,4 +154,5 @@
 extern void rmixl_obio_eb_bus_mem_init(bus_space_tag_t, void *);
 extern void rmixl_obio_el_bus_mem_init(bus_space_tag_t, void *);
+extern void rmixl_iobus_bus_mem_init(bus_space_tag_t, void *);
 extern void rmixl_pci_cfg_bus_mem_init(bus_space_tag_t, void *);
 extern void rmixl_pci_ecfg_bus_mem_init(bus_space_tag_t, void *);
@@ -158,4 +165,5 @@
 extern uint64_t rmixl_mfcr(u_int);
 extern void rmixl_mtcr(uint64_t, u_int);
+extern void rmixl_eirr_ack(uint64_t, uint64_t, uint64_t);
 
 
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatch.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatch.c	(revision 152)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatch.c	(revision 152)
@@ -0,0 +1,112 @@
+/*	$NetBSD: sbbuswatch.c,v 1.1.2.2 2010/06/10 17:35:04 cliff Exp $	*/
+/*
+ * Copyright (c) 2010, The NetBSD Foundation, Inc.  All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Cliff Neighbors.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/cpu.h>
+
+#include <mips/cpu.h>
+#include <mips/locore.h>
+
+#include <mips/sibyte/include/sb1250_int.h>
+#include <mips/sibyte/include/sb1250_regs.h>
+#include <mips/sibyte/dev/sbbuswatchvar.h>
+
+#define READ_REG(rp)            (mips3_ld((volatile uint64_t *)(rp)))
+#define WRITE_REG(rp, val)      (mips3_sd((volatile uint64_t *)(rp), (val)))
+
+static void sibyte_bus_watch_intr(void *, uint32_t, vaddr_t);
+
+void
+sibyte_bus_watch_init(void)
+{
+	(void)READ_REG(MIPS_PHYS_TO_KSEG1(A_SCD_BUS_ERR_STATUS));
+	WRITE_REG(MIPS_PHYS_TO_KSEG1(A_BUS_L2_ERRORS), 0);
+	WRITE_REG(MIPS_PHYS_TO_KSEG1(A_BUS_MEM_IO_ERRORS), 0);
+
+	(void)cpu_intr_establish(K_INT_BAD_ECC, IPL_DDB,
+		sibyte_bus_watch_intr, (void *)K_INT_BAD_ECC);
+	(void)cpu_intr_establish(K_INT_COR_ECC, IPL_DDB,
+		sibyte_bus_watch_intr, (void *)K_INT_COR_ECC);
+	(void)cpu_intr_establish(K_INT_IO_BUS, IPL_DDB,
+		sibyte_bus_watch_intr, (void *)K_INT_IO_BUS);
+}
+
+int
+sibyte_bus_watch_check(unsigned int cause)
+{
+	uint64_t err_ctl;
+	uint64_t cache_err_i;
+	uint64_t cache_err_d;
+	uint64_t cache_err_dpa;
+	uint64_t bus_err_dpa;
+	uint32_t bus_err_status;
+	uint32_t l2_errors;
+	uint32_t mem_io_errors;
+
+	bus_err_status = READ_REG(
+		MIPS_PHYS_TO_KSEG1(A_SCD_BUS_ERR_STATUS));
+
+	if (bus_err_status == 0)
+		return 0;
+
+	l2_errors = READ_REG(
+		MIPS_PHYS_TO_KSEG1(A_BUS_L2_ERRORS));
+	if (l2_errors != 0)
+		WRITE_REG(MIPS_PHYS_TO_KSEG1(A_BUS_L2_ERRORS), 0);
+
+	mem_io_errors = READ_REG(
+		MIPS_PHYS_TO_KSEG1(A_BUS_MEM_IO_ERRORS));
+	if (mem_io_errors != 0)
+		WRITE_REG(MIPS_PHYS_TO_KSEG1(A_BUS_MEM_IO_ERRORS), 0);
+
+	asm volatile("dmfc0 %0, $26, 0;" : "=r"(err_ctl));
+	asm volatile("dmfc0 %0, $26, 1;" : "=r"(bus_err_dpa));
+	asm volatile("dmfc0 %0, $27, 0;" : "=r"(cache_err_i));
+	asm volatile("dmfc0 %0, $27, 1;" : "=r"(cache_err_d));
+	asm volatile("dmfc0 %0, $27, 3;" : "=r"(cache_err_dpa));
+
+	printf("bus_err_status=%#x\n", bus_err_status);
+	printf("l2_errors=%#x\n", l2_errors);
+	printf("mem_io_errors=%#x\n", mem_io_errors);
+	printf("err_ctl=%#"PRIx64"\n", err_ctl);
+	printf("bus_err_dpa=%#"PRIx64"\n", bus_err_dpa);
+	printf("cache_err_i=%#"PRIx64"\n", cache_err_i);
+	printf("cache_err_d=%#"PRIx64"\n", cache_err_d);
+	printf("cache_err_dpa=%#"PRIx64"\n", cache_err_dpa);
+
+	return -1;
+}
+
+static void
+sibyte_bus_watch_intr(void *arg, uint32_t status, vaddr_t pc)
+{
+	printf("%s: %p\n", __func__, arg);
+	(void)sibyte_bus_watch_check(0);
+}
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatchvar.h
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatchvar.h	(revision 152)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbbuswatchvar.h	(revision 152)
@@ -0,0 +1,36 @@
+/*	$NetBSD: sbbuswatchvar.h,v 1.1.2.2 2010/06/10 17:33:21 cliff Exp $	*/
+/*
+ * Copyright (c) 2010, The NetBSD Foundation, Inc.  All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Cliff Neighbors.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _ARCH_SIBYTE_DEV_SBBUSWATCHVAR_H
+#define	_ARCH_SIBYTE_DEV_SBBUSWATCHVAR_H
+
+extern void sibyte_bus_watch_init(void);
+extern int  sibyte_bus_watch_check(unsigned int);
+
+#endif	/* _ARCH_SIBYTE_DEV_SBBUSWATCHVAR_H */
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbgbus.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbgbus.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbgbus.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbgbus.c,v 1.10.96.1 2009/11/23 18:28:46 matt Exp $ */
+/* $NetBSD: sbgbus.c,v 1.10.96.2 2010/06/09 14:22:16 matt Exp $ */
 
 /*
@@ -34,5 +34,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbgbus.c,v 1.10.96.1 2009/11/23 18:28:46 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbgbus.c,v 1.10.96.2 2010/06/09 14:22:16 matt Exp $");
 
 #include <sys/param.h>
@@ -48,16 +48,15 @@
 extern struct cfdriver sbgbus_cd;
 
-static int	sbgbus_match(struct device *, struct cfdata *, void *);
-static void	sbgbus_attach(struct device *, struct device *, void *);
+static int	sbgbus_match(device_t, cfdata_t, void *);
+static void	sbgbus_attach(device_t, device_t, void *);
 
-CFATTACH_DECL(sbgbus, sizeof(struct device),
+CFATTACH_DECL_NEW(sbgbus, 0,
     sbgbus_match, sbgbus_attach, NULL, NULL);
 
-static int	sbgbussearch(struct device *, struct cfdata *,
-			     const int *, void *);
+static int	sbgbussearch(device_t, cfdata_t, const int *, void *);
 static int	sbgbusprint(void *, const char *);
 
 static int
-sbgbus_match(struct device *parent, struct cfdata *match, void *aux)
+sbgbus_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct sbobio_attach_args *sap = aux;
@@ -70,5 +69,5 @@
 
 static void
-sbgbus_attach(struct device *parent, struct device *self, void *aux)
+sbgbus_attach(device_t parent, device_t self, void *aux)
 {
 
@@ -96,5 +95,5 @@
 
 static int
-sbgbussearch(struct device *parent, struct cfdata *cf,
+sbgbussearch(device_t parent, cfdata_t cf,
 	     const int *ldesc, void *aux)
 {
